'CCmod by Frenkel Smeijers, version 1.0, 7 feb 2004
'frenkel_smeijers@hotmail.com
'http://www.sfprod.cjb.net
'
'If you use my code, credit me!

CONST deelgrootte% = 8003 '2048
DIM deel AS STRING * deelgrootte
DIM deelbmp AS STRING * 13312
DIM bp(0 TO 3) AS INTEGER 'bitplane

TYPE BMPHeaderType
  id AS STRING * 2      'Should be "BM"
  size AS LONG          'Size of the file
  reserved AS LONG      '
  offset AS LONG        'Position of start of pixel data
  sizeheader AS LONG    '
  wid AS LONG           'Image width
  hei AS LONG           'Image height
  planes AS INTEGER     '
  bpp AS INTEGER        'Should read 4 for a 16 colour image
  compression AS LONG   '
  sizeimage AS LONG     'Width*Height
  xres AS LONG          '
  yres AS LONG          '
  colorused AS LONG     '
  colorimportant AS LONG'
  pal AS STRING * 64    'Stored as <Blue, Green, Red, 0>
END TYPE

DIM BH AS BMPHeaderType 'BMPHeader

PRINT "CCmod by Frenkel Smeijers, version 1.0, 7 feb 2004"
PRINT "frenkel_smeijers@hotmail.com"
PRINT "http://www.sfprod.cjb.net"
PRINT
INPUT "Episode (1, 2 or 3)"; episode%
IF episode% < 1 OR episode% > 3 THEN END

episode$ = LTRIM$(STR$(episode%))
bmp$ = "Cc" + episode$ + "tiles.bmp"
ccgfx$ = "Cc" + episode$ + ".gfx"

INPUT "1) Export to Bmp; 2) Inport to Cc#.gfx"; eoi%
IF eoi% = 1 THEN
  GOTO CCtoBMP
ELSEIF eoi% = 2 THEN
  GOTO BMPtoCC
ELSE
  END
END IF

'''''''''
'CCtoBMP'
'''''''''
CCtoBMP:

BH.id = "BM"
BH.size = 306294
BH.reserved = 0
BH.offset = 118
BH.sizeheader = 40
BH.wid = 128
BH.hei = 4784
BH.planes = 1
BH.bpp = 4
BH.compression = 0
BH.sizeimage = 306176
BH.xres = 0
BH.yres = 0
BH.colorused = 16
BH.colorimportant = 16
'palette
palet$ = CHR$(0) + CHR$(0) + CHR$(0) + CHR$(0) + CHR$(168) + CHR$(0) + CHR$(0)
palet$ = palet$ + CHR$(0) + CHR$(0) + CHR$(168) + CHR$(0) + CHR$(0)
palet$ = palet$ + CHR$(168) + CHR$(168) + CHR$(0) + CHR$(0) + CHR$(0)
palet$ = palet$ + CHR$(0) + CHR$(168) + CHR$(0) + CHR$(168) + CHR$(0)
palet$ = palet$ + CHR$(168) + CHR$(0) + CHR$(0) + CHR$(84) + CHR$(168)
palet$ = palet$ + CHR$(0) + CHR$(168) + CHR$(168) + CHR$(168) + CHR$(0)
palet$ = palet$ + CHR$(84) + CHR$(84) + CHR$(84) + CHR$(0) + CHR$(252)
palet$ = palet$ + CHR$(84) + CHR$(84) + CHR$(0) + CHR$(84) + CHR$(252)
palet$ = palet$ + CHR$(84) + CHR$(0) + CHR$(252) + CHR$(252) + CHR$(84)
palet$ = palet$ + CHR$(0) + CHR$(84) + CHR$(84) + CHR$(252) + CHR$(0)
palet$ = palet$ + CHR$(252) + CHR$(84) + CHR$(252) + CHR$(0) + CHR$(84)
palet$ = palet$ + CHR$(252) + CHR$(252) + CHR$(0) + CHR$(252) + CHR$(252)
palet$ = palet$ + CHR$(252) + CHR$(0)
BH.pal = palet$

OPEN ccgfx$ FOR BINARY ACCESS READ AS #1
IF LOF(1) = 0 THEN
  PRINT "Can't find " + ccgfx$
  CLOSE #1
  KILL ccgfx$
  END
ELSEIF LOF(1) <> 184069 THEN
  PRINT ccgfx$ + " hasn't got the right file size."
  CLOSE #1
  END
END IF

OPEN bmp$ FOR BINARY ACCESS WRITE AS #2
PUT #2, , BH

SCREEN 9
WIDTH , 43

LOCATE 25, 5: PRINT "DONT"
LOCATE 26, 5: PRINT "USE!"
LOCATE 25, 13: PRINT "USE-"
LOCATE 26, 13: PRINT "LESS"

DEF SEG = &HA000
FOR m% = 1 TO 23

  GET #1, , deel
 
  'viewing
  aantal% = ASC(MID$(deel, 1, 1)) - 1
  breedte% = ASC(MID$(deel, 2, 1)) - 1
  hoogte% = ASC(MID$(deel, 3, 1)) - 1

  FOR i% = -1 TO 3
    IF i% = -1 THEN
      OUT &H3C4, 2
      OUT &H3C5, 15
    ELSE
      OUT &H3C4, 2
      OUT &H3C5, 2 ^ i%
    END IF
    j% = i%
    FOR n% = 0 TO aantal% '49
      coor% = (n% \ 4) * 1280 + (n% MOD 4) * 2
      FOR y% = 0 TO hoogte%
        y3% = y% * 80
        FOR x% = 0 TO breedte%
          memoffset% = y3% + x% + coor%
          j% = j% + 5
          byte% = ASC(MID$(deel, j%, 1))
          IF i% = -1 THEN
            POKE memoffset% + 8, NOT byte%
          ELSE
            POKE memoffset%, byte%
          END IF
        NEXT x%
      NEXT y%
    NEXT n%
  NEXT i%

  'dumping
  j% = 0
  FOR y% = 207 TO 0 STEP -1
    FOR x% = 0 TO 127 STEP 2
      j% = j% + 1
      MID$(deelbmp, j%, 1) = CHR$((POINT(x%, y%) * 16) + POINT(x% + 1, y%))
    NEXT x%
  NEXT y%
  PUT #2, BH.size - 13312& * m% + 1, deelbmp
  
NEXT m%

GOTO Einde



'''''''''
'BMPtoCC'
'''''''''
BMPtoCC:


OPEN bmp$ FOR BINARY ACCESS READ AS #1
IF LOF(1) = 0 THEN
  PRINT "Can't find " + bmp$
  CLOSE #1
  KILL bmp$
  END
ELSEIF LOF(1) <> 306294 THEN
  PRINT bmp$ + " hasn't got the right file size."
  CLOSE #1
  END
END IF

GET #1, , BH

OPEN ccgfx$ FOR BINARY ACCESS WRITE AS #2

SCREEN 9
WIDTH , 43

DEF SEG = &HA000
FOR m% = 1 TO 23
 
  'viewing
  GET #1, BH.size - 13312& * m% + 1, deelbmp
  j% = 0
  FOR y% = 207 TO 0 STEP -1
    FOR x% = 0 TO 127 STEP 2
      j% = j% + 1
      kleur% = ASC(MID$(deelbmp, j%, 1))
      PSET (x%, y%), kleur% \ 16
      PSET (x% + 1, y%), kleur% AND 15
    NEXT x%
  NEXT y%

  'dumping to deel
  MID$(deel, 1, 1) = CHR$(50) '"2"   'aantal
  MID$(deel, 2, 1) = CHR$(2)  '""   'breedte
  MID$(deel, 3, 1) = CHR$(16) '""   'hoogte

  j% = 3
  FOR n% = 0 TO 49
    coor% = (n% \ 4) * 1280 + (n% MOD 4) * 2
    FOR y% = 0 TO 15
      y2% = y% * 80
      FOR x% = 0 TO 1
        memoffset% = y2% + x% + coor%
        j% = j% + 1
        FOR i% = 0 TO 3
          j% = j% + 1
          OUT &H3CE, 4
          OUT &H3CF, i%
          MID$(deel, j%, 1) = CHR$(PEEK(memoffset%))
          bp(i%) = (NOT PEEK(memoffset% + 8)) AND 255
        NEXT i%
        MID$(deel, j% - 4, 1) = CHR$(bp(0) OR bp(1) OR bp(2) OR bp(3))
      NEXT x%
    NEXT y%
  NEXT n%

  'dumping to file
  PUT #2, , deel

NEXT m%

Einde:
DEF SEG
CLOSE #1, #2
END

